#include <iostream>
#include <fstream>
#include <cmath>
#include <cstdlib>
#include <map>
#include <set>
#include <vector>
#include <cstring>
#include <string>
#include <algorithm>
#include <queue>

using namespace std;

const int nmax = 1e5;
const int inf = 1e9;

vector <int> g[nmax];
vector <int> w[nmax];

queue <int> q[2];

int t[nmax];
int n,m;

int bfs(int v, int u)
{
	for (int i = 0; i < n; i ++)
		t[i] = inf;
	t[v] = 0;
	q[0].push(v);
	int cur_dist = 0;
	while (q[0].size() + q[1].size() > 0)
	{
		while (q[0].size() > 0)
		{
			int v = q[0].front(); q[0].pop();
			for (int i = 0; i < g[v].size(); i ++)
			{
				int u = g[v][i];
				int c = w[v][i];
				if (t[u] > t[v] + c)
				{
					t[u] = t[v] + c;
					q[c].push(u);
				}
			}
		}
		swap(q[0], q[1]);
	}
	return (t[u] > n ? -1 : t[u]);
}

int main()	
{
	cin >> n >> m;
	for (int i = 0; i < m; i ++)
	{
		int x,y;
		cin >> x >> y;
		x --; y --;
		g[x].push_back(y);
		w[x].push_back(0);
		g[y].push_back(x);
		w[y].push_back(1);
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; i ++)
	{
		int u,v;
		cin >> u >> v;
		u --; v --;
		cout << bfs(u, v) << endl;
	}
	return 0;
}
