#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

const int MX_M = 250;
const int MX_K = 5000;

int n, m, k;
int way[MX_M][MX_M];
int town[MX_K], start[MX_K], finish[MX_K], number[MX_K];
int dm[MX_K];
const int inf = (int)1e9;

void read_graph(void){
    for (int i = 0; i < m; ++i)
        for (int j = 0; j < m; ++j)
            cin >> way[i][j];
    for (int k = 0; k < m; ++k)
        for (int i = 0; i < m; ++i)
            for (int j = 0; j < m; ++j)
                way[i][j] = min(way[i][j], way[i][k] + way[k][j]);
}

void read_shedule(void){
    vector<pair<pair<int, int>, pair<int, int> > > v;
    for (int i = 0; i < k; ++i){
        int g, s, f;
        cin >> g >> s >> f;
        v.push_back(make_pair(make_pair(f, s), make_pair(g, i)));
    }
    for (int i = 0; i < k; ++i)
        town[i] = v[i].second.first - 1, start[i] = v[i].first.second, finish[i] = v[i].first.first, number[i] = v[i].second.second;
}

void read(void){
    cin >> n >> m >> k;
    read_graph();
    read_shedule();
}

int main(void){
    read();
    int ans = 0, ans_end = -1;
    for (int i = 0; i < k; ++i){
        if (1 + way[0][town[i]] > start[i]){
            dm[i] = -inf;
            continue;
        }
        dm[i] = 1;
        if (finish[i] + way[town[i]][0] <= n)
            if (dm[i] > ans)
                ans = dm[i], ans_end = i;        
    }
    int is_changed = k;
    while (is_changed){
        is_changed--;
        for (int i = 0; i < k; ++i){
            if (1 + way[0][town[i]] > start[i]){
                dm[i] = -inf;
                continue;
            }
            for (int j = 0; j < k; ++j)
                if (finish[j] + way[town[j]][town[i]] <= start[i])
                    if (dm[i] < dm[j] + 1){
                        dm[i] = dm[j] + 1;
                    }
            if (finish[i] + way[town[i]][0] <= n)
                if (dm[i] > ans)
                    ans = dm[i], ans_end = i;
        }
    }
    cout << ans << endl;
}
