#include <cstdio>
using namespace std;

typedef long long llong;

const int N = 42;
char msk[N];
int n;

llong vsym()
{
    int vs[] = {0, 1, -1, 3, -1, -1, -1, -1, 8, -1};
    bool bad = false;
    if (n != 1 && msk[0] == '0')
        return 0;
    llong ans = 1;
    for (int i = 0; i < n; i++)
    {
        if (msk[i] != '*')
            bad |= vs[msk[i] - '0'] == -1;
        else
            ans = ans * (3 + (!!i || (n == 1)));
    }
    return ans * !bad;
}

llong hsym()
{
    int hs[] = {0, 1, 5, -1, -1, 2, -1, -1, 8, -1};
    bool bad = false;
    if (n != 1 && msk[0] == '0' || msk[n - 1] == '0')
        return 0;
    llong ans = 1;
    for (int i = 0; i <= (n - 1) / 2; i++)
    {
        if (msk[i] != '*' && msk[n - 1 - i] != '*')
            bad |= hs[msk[i] - '0'] != msk[n - 1 - i] - '0';
        else if (msk[n - 1 - i] != '*')
            bad |= hs[msk[n - 1 - i] - '0'] == -1;
        else if (msk[i] != '*')
            bad |= hs[msk[i] - '0'] == -1;
        else
            ans = ans * (4 + (!!i || (n == 1)) - 2 * (2 * i + 1 == n));
    }
    return ans * !bad;
}

llong bsym()
{
    int bs[] = {0, 1, -1, -1, -1, -1, -1, -1, 8, -1};
    bool bad = false;
    if (n != 1 && msk[0] == '0' || msk[n - 1] == '0')
        return 0;
    llong ans = 1;
    for (int i = 0; i <= (n - 1) / 2; i++)
    {
        if (msk[i] != '*' && msk[n - 1 - i] != '*')
            bad |= bs[msk[i] - '0'] != msk[n - 1 - i] - '0';
        else if (msk[n - 1 - i] != '*')
            bad |= bs[msk[n - 1 - i] - '0'] == -1;
        else if (msk[i] != '*')
            bad |= bs[msk[i] - '0'] == -1;
        else
            ans = ans * (2 + (!!i || (n == 1)));
    }
    return ans * !bad;
}

int main()
{
    scanf("%d ", &n);
    gets(msk);
    llong v = vsym();
    llong h = hsym();
    llong b = bsym();
    fprintf(stderr, "%lld %lld %lld\n", v, h, b);
    printf("%I64d\n", v + h - b);
    return 0;
}

