#include <cassert>
#include <cstdio>
#include <vector>
using namespace std;

// ###
// ###
// ###

// m > n
// x = 2nm + m - n = 1/2 (4nm + 2m - 2n) = 1/2 ((2n + 1)(2m - 1) + 1)
// m <= n
// x = 2nm - m + n + 1 = 1/2(4nm + 2n - 2m + 2) = 1/2((2n - 1)(2m + 1) + 3)

int get(int n, int m)
{
    assert(1010000000 / n > m);
    int ans = 2 * n * m + n + m;
    if (m <= n)
        ans -= 2 * m - 1;
    else
        ans -= 2 * n;
    return ans;
}

const int UP = 30000;

int main()
{
    int x;
    vector<pair<int, int> > ans;
    scanf("%d", &x);
    
    for (int m = 1; m <= UP; m++)
    {
        // m <= n
        // 2nm + n - m + 1 = x
        // n(2m + 1) = x + m - 1
        int en = x + m - 1;
        int de = 2 * m + 1;
        if (en % de != 0)
            continue;
        int n = en / de;
        if (m > n || n <= 0)
            continue;
        assert(get(n, m) == x);
        ans.push_back(make_pair(n, m));
    }
    
    for (int n = 1; n <= UP; n++)
    {
        // m > n
        // 2nm + m - n = x
        // m(2n + 1) = x + n
        int en = x + n;
        int de = 2 * n + 1;
        if (en % de != 0)
            continue;
        int m = en / de;
        if (m <= n || m <= 0)
            continue;
        assert(get(n, m) == x);
        ans.push_back(make_pair(n, m));
    }

    printf("%d\n", ans.size());
    for (int i = 0; i < ans.size(); i++)
        printf("%d %d\n", ans[i].first, ans[i].second);
    return 0;
}
