#!/usr/bin/python3

from sys import *

adds = 0
subs = 0
muls = 0
les = 0
ges = 0
eqs = 0
lts = 0
gts = 0
nes = 0
assigns = 0
ands = 0
ors = 0
nots = 0


class Int:
	def __init__(self, value):
		self.x = value
	def __add__(self, rhs):
		global adds; adds += 1
		return Int(self.x + rhs.x);
	def __sub__(self, rhs):
		global subs; subs += 1
		return Int(self.x - rhs.x);
	def __div__(self, rhs):
		global divs; divs += 1
		return Int(self.x // rhs.x)
	def __mul__(self, rhs):
		global muls; muls += 1
		return Int(self.x * rhs.x)
	def __le__(self, rhs):
		global les; les += 1
		return self.x <= rhs.x
	def __ge__(self, rhs):
		global ges; ges += 1
		return self.x >= rhs.x
	def __eq__(self, rhs):
		global eqs; eqs += 1
		return self.x == rhs.x
	def __ne__(self, rhs):
		global nes; nes += 1
		return self.x != rhs.x
	def __lt__(self, rhs):
		global lts; lts += 1
		return self.x < rhs.x
	def __gt__(self, rhs):
		global gts; gts += 1
		return self.x > rhs.x
	def __neg__(self):
		global subs; subs += 1
		return Int(-self.x)

def prep(x):
	X = x.split()
	for i in range(len(X)):
		if X[i] == 'and':
			X[i] = '*'
		if X[i] == 'or':
			X[i] = '+'
	return ' '.join(X)

def upd(x):
	x = x.strip()
	if x[:3] == 'if ':
		return 'if g("' + x[3:-1] + '") :';
	if x[:6] == 'while ':
		return 'while g("' + x[6:-1] + '") :';
	if x.replace('==', '').replace('<=', '').replace('>=', '').replace('!=', '').count('=') != 0:
		return x + '; assigns += 1'
	else:
		return x

def update(x):
	shift = 0
	while 4 < len(x) and x[0: 4] == ' ' * 4:
		shift += 1
		x = x[4:]
	L = [ '=', '<', '>', ':', '(', ')', '!', '+', '-', '*' ]	
	for l in L:
		x = x.replace(l, ' ' + l + ' ')
	for l1 in L:
		for l2 in L:
			x = x.replace(l1 + '  ' + l2, l1 + l2)
	x = x.split()
#	for i in range(len(x)):
#		if x[i] == 'and':
#			x[i] = '*'
#		if x[i] == 'or':
#			x[i] = '+'
	good = lambda x: (len(x) == 1 or x[1:].isdigit()) and ((x[0] == '-' and len(x) > 1) or x.isdigit())
	t = ' '.join([ '___' + i + '___' if i.isalpha() and i not in ['if', 'while', 'and', 'or', 'not' ] else ('Int(' + i + ')' if good(i) else i) for i in x])
	return shift * 4 * ' ' + upd(t)

def f(x):
	global assigns; assigns += 1
	L = [ '=', '<', '>', ':', '(', ')', '!', '+', '-', '*' ]	
	X = x
	for i in L:
		X = X.replace(i, '')
	exec(x)
	l = locals()
	for i in l:
		if i[:3] == '_' * 3:
			globals()[i] = l[i]

def g(x):
	X = x.split()
	global ands; ands += len(list(filter(lambda x: x == 'and', X)))
	global ors; ors += len(list(filter(lambda x: x == 'or', X)))
	global nots; nots += len(list(filter(lambda x: x == 'not', X)))
	for i in range(len(X)):
		if X[i] == 'and':
			X[i] = '*'
		if X[i] == 'or':
			X[i] = '+'
	return eval(' '.join(X))

commands = '\n'.join(list(map(update, stdin.readlines())))
exec(commands)
g = list(globals())
ans = [] 
for i in g: 
	if i.startswith('___') and i.endswith('___'):
		var = i[3:-3]
		ans.append((var, str(eval(i).x)))

ops = {}
ops['+'] = adds
ops['-'] = subs
ops['*'] = muls
ops['<='] = les
ops['>='] = ges
ops['=='] = eqs
ops['<'] = lts
ops['>'] = gts
ops['!='] = nes
ops['='] = assigns
ops['and'] = ands
ops['or'] = ors
ops['not'] = nots

opers = []
for i in ops:
	if ops[i] != 0:
		opers.append((i, str(ops[i])))

opers.sort()
for (i, j) in opers:
	print(i + ': ' + j)
print('total %d operations' % sum([ops[i] for i in ops]))
stdout.write('\n')

ans.sort()
for (i, j) in ans:
	print(i + ': ' + j)
