#include <iostream>
#include <cstdio>
#include <string>
#include <memory.h>
#include <vector>
#include <ctime>
#include <cassert>
using namespace std;

const int N = 52;
int A[N][N];

int usedA[N], usedB[N], was[N];
int usedAsz, usedBsz;
int best_res[N];
int res[N];
int cur = 0;
int best = -1e9;
double start_time;
int K;

void rec(int v){
    if (v == usedAsz){
        if (cur > best){
            best = cur;
            for (int i = 0; i < usedAsz; ++i)
                best_res[usedA[i]] = res[usedA[i]];
        }
        return;
    }
    
    res[usedA[v]] = -1;
    rec(v + 1);
    
    for (int i = 0; i < usedBsz; ++i)
        if (!was[i]){
            was[i] = 1;
            res[usedA[v]] = usedB[i];
            cur += A[usedA[v]][usedB[i]];
            rec(v + 1);
            cur -= A[usedA[v]][usedB[i]];
            was[i] = 0;
        }
}

pair<int, vector<int> > solve(){
    int wasA[N], wasB[N];
    memset(wasA, 0, sizeof(wasA));
    memset(wasB, 0, sizeof(wasB));
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < N; ++j)
            wasA[i] += A[i][j], wasB[j] += A[i][j];
    for (int i = 0; i < N; ++i){
        if (wasA[i])
            usedA[usedAsz++] = i;
        if (wasB[i])
            usedB[usedBsz++] = i;
    }
    for (int i = 0; i < N; ++i)
        best_res[i] = -1;
    rec(0);
    for (int i = 0; i < K; ++i)
        wasB[i] = 0;
    for (int i = 0; i < K; ++i)
        if (best_res[i] != -1)
            wasB[best_res[i]] = 1;
    for (int i = 0, j = 0; i < K && j < K; ++i, ++j){
        while (i < K && best_res[i] != -1)
            i++;
        while (j < K && wasB[j])
            j++;
        if (i == K || j == K){
            assert(i == K && j == K);
            break;
        }
        best_res[i] = j;
    }
    return make_pair(best, vector<int>(best_res, best_res + N) );
}

int to_number(char c){
    if ('a' <= c && c <='z')
        return c - 'a';
    else
        return c - 'A' + 26;
}

char to_letter(int i){
    if (i < 26)
        return i + 'a';
    else
        return i - 26 + 'A';
}

int main(){
    start_time = clock();
    int n;
    cin >> n >> K;
    string first, second;
    cin >> first >> second;
    
    assert(first.length() == second.length());
    for (int i = 0; i < (int)first.length(); ++i)
        A[to_number(first[i])][to_number(second[i])]++;
    
    pair<int, vector<int> > ans = solve();
    cout << ans.first << endl;
    for (int i = 0; i < K; ++i)
        cout << to_letter(ans.second[i]);
    cout << endl;
    
    cerr << (clock() - start_time) / CLOCKS_PER_SEC << endl;
    return 0;
}
