#include <cstdio>

#include "valuer.h"

using namespace NValuer;

int main()
{
    TValuer valuer(TValuer::FullScore, 60);
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 1, 3, 0));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 4, 15, 15));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 16, 40, 15));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 41, 75, 30));
    valuer.Add(TestGroup(TestGroup::AllOrNothing, 76, 115, 40), TValuer::Offline);

    if (!valuer.Ok(100)) {
        return 43;
    }

    TEjudgeCheckResultParser parser;
    printf("%d %d %d %d", valuer.CalcScore(parser), -1,  valuer.CalcScore(parser, true), -1);

    return 0;
}

